<?
require_once('includes/common.php');
require_once('includes/Project.php');
require_once('includes/Company.php');
require_once('includes/Task.php');
require_once('includes/Invoice.php');
require_once('includes/Check.php');

checkLogin('accounting');

$project = new Project();

$company = new Company();
$companies = $company->getCompanysWithUnbilledAmount();
if($companies === FALSE){
	$error_msg .= "Could not retrieve Outstanding Hours list!\n";
	debug_message($company->getLastError());
}

$user = new User();
$users = $user->getUnpaidUsers();
if($users === FALSE){
	$error_msg .= "Could not retrieve Unpaid Users's list!\n";
	debug_message($user->getLastError());
}

$invoice = new Invoice();
$invoices = $invoice->getOutstanding();
if($invoices === FALSE){
	$error_msg .= "Could not retrieve Outstanding Invoice list!\n";
	debug_message($invoice->getLastError());
}

$check = new Check();
$checks = $check->retrieveSet("ORDER BY timestamp DESC LIMIT 5");
if($checks === FALSE){
	$error_msg .= "Could not retrieve Check list!\n";
	debug_message($check->getLastError());
}

$ps = new PaymentSchedule();
$ps_items = $ps->getUpcoming();
if($ps_items === FALSE){
	$error_msg .= "Could not retreive upcoming scheduled payments!\n";
	debug_message($ps->getLastError());
}
$title = "Accounting";

require('header.php'); ?>
<SCRIPT>
function reloadPage(selObj){
	var user_id = selObj.options[selObj.selectedIndex].value;
	window.location.href = "<?= $_SERVER['PHP_SELF'] ?>?filter=<?= $_REQUEST['filter'] ?>&user_id="+user_id;
}
</SCRIPT>
<TABLE BORDER="0" CELLSPACING="4" CELLPADDING="0">
<TR><TD COLSPAN="2">&nbsp;</TD></TR>
<TR>
	<TD VALIGN="top" ALIGN="center">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table" WIDTH="100%">
			<TR>
				<TD COLSPAN="4" CLASS="form_header_cell">Companies With Outstanding Hours</TD>
			</TR>
<?    if(count($companies) > 0){?>
			<TR>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId3', 0, 1, false)">Name</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId3', 1, 0, false)">Time</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId3', 2, 0, false)">Amount</A></TD>
				<TD CLASS="dg_header_cell">Options</TD>
			</TR>
			<TBODY ID="bodyId3">
		<? for($i = 0; $i < count($companies); $i++){
				$company_time_total += $companies[$i]->time_spent;
				$company_amount_total += $companies[$i]->amount;
		?>
			<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
				<TD CLASS="dg_data_cell_1"><A title="Company Detail Center" HREF="company_detail.php?id=<?= $companies[$i]->id ?>"><?= $companies[$i]->name ?></A></TD>
				<TD CLASS="dg_data_cell_1"><?= formatLengthOfTime($companies[$i]->time_spent) ?></TD>
				<TD CLASS="dg_data_cell_1">$<?= number_format($companies[$i]->amount, 2) ?></TD>
				<TD CLASS="dg_data_cell_1" nowrap>&nbsp;
					<A CLASS="link1" HREF="activities_log.php?company_id=<?= $companies[$i]->id ?>&unbilled=y&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/properties.gif" width="16" height="16" title="View Detail" border="0" /></A>
					<A CLASS="link1" HREF="invoice.php?company_id=<?= $companies[$i]->id ?>&unbilled=y&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/invoice.gif" width="16" height="16" title="Create Invoice" border="0" /></A>
				</TD>
			</TR>
		<? }?>
			</TBODY>
			<TR>
				<TD CLASS="form_header_cell" ALIGN="right">Total:</TD>
				<TD CLASS="dg_data_cell_1"><?= formatLengthOfTime($company_time_total) ?></TD>
				<TD CLASS="dg_data_cell_1">$<?= number_format($company_amount_total, 2) ?></TD>
				<TD CLASS="form_header_cell">&nbsp;</TD>
			</TR>
<?    }else{?>
			<TR>
				<TD COLSPAN="4" CLASS="dg_data_cell_1">None</TD>
			</TR>
<?    }?>
		</TABLE>
	</TD>
	<TD VALIGN="top" ALIGN="center">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table" WIDTH="100%">
			<TR>
				<TD COLSPAN="3" CLASS="form_header_cell">Unpaid Resources</TD>
			</TR>
<?   	if(count($users) > 0){?>
			<TR>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId4', 0, 1, false)">Name</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId4', 1, 0, false)">Amount</A></TD>
				<TD CLASS="dg_header_cell">Options</TD>
			</TR>
			<TBODY ID="bodyId4">
		<? for($i = 0; $i < count($users); $i++){
				$user_amount_total += $users[$i]->amount;
		?>
			<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
				<TD CLASS="dg_data_cell_1"><A title="Resource Detail Center" HREF="home_resource.php?id=<?= $users[$i]->id ?>"><?= $users[$i]->first_name.' '.$users[$i]->last_name ?></A></TD>
				<TD CLASS="dg_data_cell_1"><?= $users[$i]->amount ?></TD>
				<TD CLASS="dg_data_cell_1" nowrap>&nbsp;
					<A CLASS="link1" HREF="activities_log.php?user_id=<?= $users[$i]->id ?>&unpaid=y&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/properties.gif" width="16" height="16" title="View Detail" border="0" /></A>
					<A CLASS="link1" HREF="check.php?user_id=<?= $users[$i]->id ?>&unpaid=y&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/check.gif" width="16" height="16" title="Create Check" border="0" /></A>
				</TD>
			</TR>
		<? }?>
		</TBODY>
			<TR>
				<TD CLASS="form_header_cell" ALIGN="right">Total:</TD>
				<TD CLASS="dg_data_cell_1">$<?= number_format($user_amount_total, 2) ?></TD>
				<TD CLASS="form_header_cell">&nbsp;</TD>
			</TR>
<?    }else{?>
			<TR>
				<TD COLSPAN="3" CLASS="dg_data_cell_1">None</TD>
			</TR>
<?    }?>
		</TABLE>
	</TD>
</TR>
<TR><TD COLSPAN="2">&nbsp;</TD></TR>
<TR>
	<TD COLSPAN="2" VALIGN="top" ALIGN="LEFT">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table" WIDTH="100%">
			<TR>
				<TD COLSPAN="7" CLASS="form_header_cell">Upcoming Scheduled Payments</TD>
			</TR>
<?    if(count($ps_items) > 0){?>
			<TR>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId5', 0, 1, false)">Company</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId5', 1, 0, false)">Project</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId5', 2, 0, false)">Task</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId5', 3, 0, false)">Due Date</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId5', 4, 0, false)">Description</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId5', 5, 0, false)">Amount</A></TD>
				<TD CLASS="dg_header_cell">Options</TD>
			</TR>
			<TBODY ID="bodyId1">
		<? for($i = 0; $i < count($ps_items); $i++){
				$ps_total += $ps_items[$i]->amount;
				$company = $ps_items[$i]->getCompany();
		?>
			<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
				<TD CLASS="dg_data_cell_1"><A title="Company Detail Center" HREF="company_detail?id="<?= $company->id ?>"><?= $ps_items[$i]->getCompanyName() ?></A></TD>
				<TD CLASS="dg_data_cell_1"><?= $ps_items[$i]->getProjectName() ?></TD>
				<TD CLASS="dg_data_cell_1"><?= $ps_items[$i]->getTaskName() ?></TD>
				<TD CLASS="dg_data_cell_1"><?= $ps_items[$i]->due_ts>0 ? date("n/j/y", $ps_items[$i]->due_ts) :  "" ?></TD>
				<TD CLASS="dg_data_cell_1"><?= $ps_items[$i]->description ?></TD>
				<TD CLASS="dg_data_cell_1">$<?= number_format($ps_items[$i]->amount, 2) ?></TD>
				<TD CLASS="dg_data_cell_1">&nbsp;
					<A CLASS="link1" HREF="invoice.php?company_id=<?= $company->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/invoice.gif" width="16" height="16" title="Create Invoice" border="0" /></A>&nbsp;
					<A CLASS="link1" HREF="payment_schedule.php?mode=edit&id=<?= $items[$i]->id ?>"><img src="images/edit.gif" width="16" height="16" title="Edit Payment Schedule" border="0" /></A>&nbsp;
					<A CLASS="link1" HREF="payment_schedule.php?mode=delete&id=<?= $items[$i]->id ?>"><img src="images/delete.gif" width="16" height="16" title="Delete Payment Schedule" border="0" /></A>&nbsp;
				</TD>
			</TR>
		<? }?>
			</TBODY>
			<TR>
				<TD COLSPAN="5" CLASS="form_header_cell" ALIGN="right">Total:</TD>
				<TD CLASS="dg_data_cell_1">$<?= number_format($ps_total, 2) ?></TD>
				<TD CLASS="form_header_cell">&nbsp;</TD>
			</TR>
<?    }else{?>
			<TR>
				<TD COLSPAN="7" CLASS="dg_data_cell_1">None</TD>
			</TR>
<?    }?>
		</TABLE>
	</TD>
</TR>
<TR><TD COLSPAN="2">&nbsp;</TD></TR>
<TR>
	<TD VALIGN="top" ALIGN="LEFT">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table" WIDTH="100%">
			<TR>
				<TD COLSPAN="5" CLASS="form_header_cell">Outstanding Invoices</TD>
			</TR>
<?    if(count($invoices) > 0){?>
			<TR>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 0, 1, false)">Number</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 1, 0, false)">Date</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 2, 0, false)">Company</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 3, 0, false)">Amount</A></TD>
				<TD CLASS="dg_header_cell">Options</TD>
			</TR>
			<TBODY ID="bodyId1">
		<? for($i = 0; $i < count($invoices); $i++){
				$invoice_total += $invoices[$i]->getTotal();
		?>
			<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
				<TD CLASS="dg_data_cell_1"><?= $invoices[$i]->id ?></TD>
				<TD CLASS="dg_data_cell_1"><?= date("n/j/y", $invoices[$i]->timestamp) ?></TD>
				<TD CLASS="dg_data_cell_1"><A title="Company Detail Center" HREF="company_detail.php?id=<?= $invoices[$i]->company_id ?>"><?= $invoices[$i]->getName(); ?></A></TD>
				<TD CLASS="dg_data_cell_1">$<?= number_format($invoices[$i]->getAmountDue(), 2) ?></TD>
				<TD CLASS="dg_data_cell_1" nowrap>&nbsp;
					<A CLASS="link1" HREF="invoice_view.php?id=<?= $invoices[$i]->id ?>"><img src="images/properties.gif" width="16" height="16" title="View Invoice" border="0" /></A>
					<A CLASS="link1" HREF="invoice_pdf.php?id=<?= $invoices[$i]->id ?>"><img target="invoice_window" src="images/acrobat.gif" width="15" height="16" title="View Invoice PDF" border="0" /></A>
					<A CLASS="link1" HREF="invoice_email.php?id=<?= $invoices[$i]->id ?>"><img src="images/email.png" width="16" height="16" title="Email Invoice" border="0" /></A>
					<A CLASS="link1" HREF="payment.php?mode=add&company_id=<?= $invoices[$i]->company_id ?>"><img src="images/payment.png" border="0" width="16" height="16" title="Recieve Payment"></A>
				</TD>
			</TR>
		<? }?>
			</TBODY>
			<TR>
				<TD COLSPAN="3" CLASS="form_header_cell" ALIGN="right">Total:</TD>
				<TD CLASS="dg_data_cell_1">$<?= number_format($invoice_total, 2) ?></TD>
				<TD CLASS="form_header_cell">&nbsp;</TD>
			</TR>
<?    }else{?>
			<TR>
				<TD COLSPAN="5" CLASS="dg_data_cell_1">None</TD>
			</TR>
<?    }?>
		</TABLE>
	</TD>
	<TD VALIGN="top" ALIGN="LEFT">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table" WIDTH="100%">
			<TR>
				<TD COLSPAN="5" CLASS="form_header_cell">Recent Checks</TD>
			</TR>
<?    if(count($checks) > 0){?>
			<TR>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 0, 1, false)">Number</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 1, 0, false)">Date</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 2, 0, false)">User</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 3, 0, false)">Amount</A></TD>
				<TD CLASS="dg_header_cell">Options</TD>
			</TR>
			<TBODY ID="bodyId2">
<?    for($i = 0; $i < count($checks); $i++){	?>
			<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
				<TD CLASS="dg_data_cell_1"><?= $checks[$i]->number ?></TD>
				<TD CLASS="dg_data_cell_1"><?= date("n/j/y", $checks[$i]->timestamp) ?></TD>
				<TD CLASS="dg_data_cell_1"><A title="Resource Detail Center" HREF="home_resource.php?id=<?= $checks[$i]->user_id ?>"><?= $checks[$i]->name ?></a></TD>
				<TD CLASS="dg_data_cell_1">$<?= number_format($checks[$i]->amount, 2) ?></TD>
				<TD CLASS="dg_data_cell_1" nowrap>&nbsp;
					<A CLASS="link1" HREF="activities_log.php?check=<?= $checks[$i]->number ?>"><img src="images/properties.gif" width="16" height="16" title="View Details" border="0" /></A>
				</TD>
			</TR>
<?    }?>
			</TBODY>
			<TR>
				<TD COLSPAN="5" CLASS="form_header_cell" ALIGN="right"></TD>
			</TR>
<?    }else{?>
			<TR>
				<TD COLSPAN="5" CLASS="dg_data_cell_1">None</TD>
			</TR>
<?    }?>
		</TABLE>
	</TD>
</TR>
</TABLE>
<? require('footer.php') ?>
