<?php
require_once('includes/common.php');
require_once('includes/Project.php');
require_once('includes/Company.php');
require_once('includes/Task.php');

checkLogin();
$project = new Project();

if($loggedin_user->hasRight('admin') && isset($_REQUEST['id'])){
	$user_id = $_REQUEST['id'];
}else{
	$user_id = $loggedin_user->id;
}

$user = new User();
if($user->get($user_id) === FALSE){
	$error_msg .= "Error getting user information!\n";
	debug_message($user->getLastError());
}

$balance = $user->getBalance();
if($balance === FALSE){
	$error_msg .= "Error getting your outstanding balance!";
	debug_message($loggedin_user->getLastError());
}

$transactions = $user->getTransactions(NULL, 5);
if($transactions === FALSE){
	$error_msg .= "Error getting your last 5 transactions!";
	debug_message($user->getLastError());
}

$task = new Task();
$tasks = $task->getUpcoming($user->id, 0, 0, 10);
if($tasks === FALSE){
	$error_msg .= "Could not retrieve Upcoming Tasks!\n";
	debug_message($task->getLastError());
}

$title = "Home";

require('header.php'); 
?>
<SCRIPT>
function reloadPage(selObj){
	var user_id = selObj.options[selObj.selectedIndex].value;
	window.location.href = "<?= $_SERVER['PHP_SELF'] ?>?filter=<?=$_REQUEST['filter'] ?>&user_id="+user_id;
}
</SCRIPT>
<TABLE BORDER="0" CELLSPACING="4" CELLPADDING="0">
<TR>
	<TD VALIGN="top" ALIGN="LEFT">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table" WIDTH="200">
			<TR>
				<TD COLSPAN="2" CLASS="form_header_cell">Your Information</TD>
			</TR>
			<TR>
				<TD CLASS="form_field_cell" COLSPAN="2">
					<B><?= $user->first_name.' '.$user->last_name ?></B><BR>
					<?= $user->address1.( !empty($user->address2) ? '<BR>'.$user->address2 : '' )?><BR>
					<?= $user->city.', '.$user->state.'   '.$user->zip ?>
					<DIV ALIGN="right"><A HREF="profile.php?id=<?= $user->id ?>">Update</A></DIV>
				</TD>
			</TR>
		</TABLE>
	</TD>
	<TD VALIGN="top" ALIGN="LEFT">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
			<TR>
				<TD COLSPAN="2" CLASS="form_header_cell">Your Account</TD>
			</TR>
			<TR>
				<TD CLASS="form_field_cell" COLSPAN="2">
					<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0">
<?	for($i=0; $i<count($transactions); $i++){ ?>
					<TR>
						<TD><?= $transactions[$i]->description ?>&nbsp;</TD>
						<TD ALIGN="right">&nbsp;&nbsp;<?= $transactions[$i]->amount ?></TD>
					</TR>
<?	}?>
					</TABLE><BR>
					<DIV ALIGN="left"><A HREF="user_account.php?id=<?= $user_id ?>">View All</A></DIV>
				</TD>
			</TR>
			<TR>
				<TD CLASS="form_field_header_cell">Outstanding Balance:</TD>
				<TD CLASS="form_field_cell" ALIGN="right">$<?= number_format($balance, 2) ?></TD>
			</TR>
		</TABLE>
	</TD>
</TR>
<TR>
	<TD VALIGN="top" COLSPAN="2" ALIGN="LEFT">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table" WIDTH="100%">
			<TR>
				<TD COLSPAN="5" CLASS="form_header_cell">Upcoming Tasks</TD>
			</TR>
			<TR>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 0, 1, false)">Project</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 1, 0, false)">Task</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 2, 0, false)">Status</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 3, 0, false)">Due Date</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 4, 0, false)">Priority</A></TD>
			</TR>
			<TBODY ID="bodyId1">
		<? for($i = 0; $i < count($tasks); $i++){ ?>
			<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
				<TD CLASS="dg_data_cell_1"><A title="Project Details" HREF="project_details.php?id=<?= $tasks[$i]->project_id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><?= $tasks[$i]->project ?></A></TD>
				<TD CLASS="dg_data_cell_1"><A title="Task Activities" HREF="task_activities.php?task_id=<?= $tasks[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><?= $tasks[$i]->name ?></A></TD>
				<TD CLASS="dg_data_cell_1"><?= $tasks[$i]->status ?></TD>
				<TD CLASS="dg_data_cell_1"><?=  $tasks[$i]->due_ts>0 ? date("n/j/y", $tasks[$i]->due_ts) : "None" ?></TD>
				<TD CLASS="dg_data_cell_1"><?= $tasks[$i]->priority ?></TD>
			</TR>
		<? }?>
		</TBODY>
		</TABLE>
	</TD>
</TR>
</TABLE>


<? require('footer.php') ?>
