<?
require_once('includes/common.php');
checkLogin();

require_once('includes/Project.php');
require_once('includes/Company.php');
require_once('includes/ProjectStatus.php');
require_once('includes/ProjectPriority.php');
require_once('includes/SalesCommissionType.php');

$title = '';
$project = new Project();

if($_REQUEST['mode'] == 'add'){
	$title = "Add Project";
	$project->owner_id = $loggedin_user->id;

	if($_POST['save']){
		$_POST['due_ts'] = getDateSelectorTS("due_ts");
		$project->updateFromAssocArray($_POST);
		if($project->id = $project->add()){
			goBack();
		}else{
			$error_msg .= "Error adding Project!\n";
			debug_message($project->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'edit'){
	$title = "Edit Project";
	if(empty($_REQUEST['id'])){
		$error_msg .= "Error: No ID specified!\n";
	}else{
		if(!$project->get($_REQUEST['id'])){
			$error_msg .= "Could not retreive project information!\n";
			debug_message($project->getLastError());
		}
		if(!$project->hasRights(PROJECT_RIGHT_EDIT)){
			fatal_error('Insufficent access rights for this project!');
		}
	}

	if($_POST['save']){
		$_POST['due_ts'] = getDateSelectorTS("due_ts");
		$project->updateFromAssocArray($_POST);
		if($project->update()){
			$activities = array("Project details modified");
			if(!empty($_FILES['attachment_file']['tmp_name'])){
				if($project->addAttachment($_FILES['attachment_file']['tmp_name'], $_FILES['attachment_file']['name'], $_POST['attachment_description']) === FALSE){
					$error_msg .= "Error adding attachment!\n";
					debug_message($project->getLastError());
				}else{
					$activities[] = "Added attachment {$_POST['attachment_description']}";
				}
			}
			if(isset($_POST['right_user_id']) && $_POST['right_user_id'] > 0){
				if(!$project->hasRights(PROJECT_RIGHT_FULL)){
					fatal_error('Insufficent access rights to add users!');
				}
				if($project->addUserRight($_POST['right_user_id'], $_POST['right_level']) === FALSE){
					$error_msg .= "Error adding user access to project!\n";
					debug_message($project->getLastError());
				}else{
					$activities[] = "Added user right level {$_POST['right_level']} to ".User::getUserName($_POST['right_user_id']);
				}
			}
			if(isset($_POST['new_cc_id']) && $_POST['new_cc_id'] > 0){
				if($project->addCC($_POST['new_cc_id']) === FALSE){
					$error_msg .= "Error adding new CC to project!\n";
					debug_message($project->getLastError());
				}else{
					$activities[] = "Added ".User::getUserName($_POST['new_cc_id'])." to project CC list";
				}
			}

			if($project->sendUpdateNotification($activities) === FALSE){
				$error_msg .= "Error sending update notification!\n";
				debug_message($project->getLastError());
			}

			if(empty($error_msg) && $_POST['save'] == "Save"){
				goBack();
			}
		}else{
			$error_msg .= "Error updating Project!\n";
			debug_message($project->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'delete'){
	$title = "Delete Project";
	$project->id = $_REQUEST['id'];

	//Make sure the user is allowed to delete this
	if(!$project->hasRights(PROJECT_RIGHT_FULL)){
		fatal_error('Insufficent access rights for this project!');
	}else{
		if($project->delete($_REQUEST['id'])){
			goBack();
		}else{
			$error_msg .= "Error deleting Project!\n";
			debug_message($project->getLastError());
		}
	}

}else if($_REQUEST['mode'] == 'delete_right'){
	$title = "Delete User Right";
	$project->get($_REQUEST['id']);

	//Make sure the user is allowed to delete
	if(!$project->hasRights(PROJECT_RIGHT_FULL)){
		fatal_error('Insufficent access rights for this project!');
	}else{
		if($project->deleteUserRight($_REQUEST['user_id']) === FALSE){
			$error_msg .= "Error deleting user access from project!\n";
			debug_message($project->getLastError());
		}
		if($project->sendUpdateNotification(array("Removed rights for user_id ".$_REQUEST['user_id'])) === FALSE){
			$error_msg .= "Error sending update notification!\n";
			debug_message($project->getLastError());
		}
		$_REQUEST['mode'] = 'edit';
	}

}else if($_REQUEST['mode'] == 'delete_attachment'){
	$title = "Delete Attachment";
	$project->get($_REQUEST['id']);

	//Make sure the user is allowed to delete
	if(!$project->hasRights(PROJECT_RIGHT_FULL)){
		fatal_error('Insufficent access rights for this project!');
	}else{
		if($project->deleteAttachment($_REQUEST['attachment_id']) === FALSE){
			$error_msg .= "Error deleting attachment from project!\n";
			debug_message($project->getLastError());
		}
		if($project->sendUpdateNotification(array("Removed attachment ID ".$_REQUEST['attachment_id'])) === FALSE){
			$error_msg .= "Error sending update notification!\n";
			debug_message($project->getLastError());
		}
		$_REQUEST['mode'] = 'edit';
	}

}else if($_REQUEST['mode'] == 'delete_cc'){
	$title = "Delete CC";
	$project->get($_REQUEST['id']);

	//Make sure the user is allowed to delete
	if(!$project->hasRights(PROJECT_RIGHT_EDIT)){
		fatal_error('Insufficent access rights for this project!');
	}else{
		if($project->deleteCC($_REQUEST['cc_id']) === FALSE){
			$error_msg .= "Error deleting cc from project!\n";
			debug_message($project->getLastError());
		}
		if($project->sendUpdateNotification(array("Removed cc ID ".$_REQUEST['attachment_id'])) === FALSE){
			$error_msg .= "Error sending update notification!\n";
			debug_message($project->getLastError());
		}
		$_REQUEST['mode'] = 'edit';
	}

}else{
	$title = "Invalid Mode";
	$error_msg .= "Error: Invalid mode!\n";
}

?>
<? require('header.php'); ?>
<SCRIPT>
function disableCom(disableIt){
	document.project.sales_com_user_id.disabled = disableIt;
	document.project.sales_com_type_id.disabled = disableIt;
}
</SCRIPT>
<FORM NAME="project" ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="POST" ENCTYPE="multipart/form-data">
<INPUT NAME="id" TYPE="hidden" VALUE="<?= $_REQUEST['id'] ?>">
<INPUT NAME="mode" TYPE="hidden" VALUE="<?= $_REQUEST['mode'] ?>">
<INPUT NAME="referrer" TYPE="hidden" VALUE="<?= $_REQUEST['referrer'] ?>">
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Name:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="name" CLASS="input_text" SIZE="45" TYPE="text" VALUE="<?= $project->name ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Status:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="project_status_id" CLASS="input_text">
			<?= ProjectStatus::getSelectTags($project->project_status_id) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Priority:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="project_priority_id" CLASS="input_text">
			<?= ProjectPriority::getSelectTags($project->project_priority_id) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Owner:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="owner_id" CLASS="input_text">
			<?= User::getSelectTags($project->owner_id) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Company:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="company_id" CLASS="input_text">
			<OPTION VALUE="0">None</OPTION>
			<?= Company::getSelectTags($project->company_id) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Due:</TD>
	<TD CLASS="form_field_cell"><?= getDateSelector($project->due_ts, "due_ts", TRUE) ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Sales Commission?</TD>
	<TD CLASS="form_field_cell">
		<INPUT NAME="sales_com" TYPE="radio" VALUE="Y" <?= checked($project->sales_com, "Y") ?> onClick="disableCom(false)">Yes&nbsp;
		<INPUT NAME="sales_com" TYPE="radio" VALUE="N" <?= checked($project->sales_com, "N") ?> onClick="disableCom(true)">No&nbsp;
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Commission User:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="sales_com_user_id" CLASS="input_text" DISABLED>
			<OPTION VALUE="0">None</OPTION>
			<?= User::getSelectTags($project->sales_com_user_id) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Commission Type:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="sales_com_type_id" CLASS="input_text" DISABLED>
			<OPTION VALUE="0">None</OPTION>
			<?= SalesCommissionType::getSelectTags($project->sales_com_type_id) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Project Billable?</TD>
	<TD CLASS="form_field_cell">
		<INPUT NAME="billable" TYPE="radio" VALUE="Y" <?= checked($project->billable, "Y") ?>>Yes&nbsp;
		<INPUT NAME="billable" TYPE="radio" VALUE="N" <?= checked($project->billable, "N") ?>>No&nbsp;
		<INPUT NAME="billable" TYPE="radio" VALUE="S" <?= checked($project->billable, "S") ?>>Spec&nbsp;
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Enable Issue Tracking?</TD>
	<TD CLASS="form_field_cell">
		<INPUT NAME="issue_tracking" TYPE="radio" VALUE="Y" <?= checked($project->issue_tracking, "Y") ?>>Yes&nbsp;
		<INPUT NAME="issue_tracking" TYPE="radio" VALUE="N" <?= checked($project->issue_tracking, "N") ?>>No&nbsp;
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Description:</TD>
	<TD CLASS="form_field_cell"><TEXTAREA NAME="description" CLASS="input_text" COLS="70" ROWS="15"><?= $project->description ?></TEXTAREA></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Attachments:</TD>
	<TD CLASS="form_field_cell">
<?  $attachments = $project->attachments;
		$attachment_count = count($attachments);
		if($attachment_count > 0){
			for($i=0; $i<$attachment_count; $i++){ ?>
		<A HREF="attachment.php?id=<?= $attachments[$i]->id ?>"><?= $attachments[$i]->path ?></A>&nbsp;-&nbsp;<?= $attachments[$i]->description ?>&nbsp;&nbsp;
		<A HREF="<?= $_SERVER['PHP_SELF']."?id=".$project->id."&mode=delete_attachment&attachment_id=".$attachments[$i]->id ?>">
		<IMG SRC="images/delete_small.gif" BORDER="0" WIDTH="13" HEIGHT="13" ALIGN="middle"/></A>&nbsp;<BR>
<?  	}
		}else{?>
		<b>No Attachments</b>
<?	} ?>
	</TD>
</TR>
<?if($_REQUEST['mode'] == 'edit' && $project->hasRights(PROJECT_RIGHT_EDIT)){?>
<TR>
	<TD CLASS="form_field_header_cell">Add Attachment:</TD>
	<TD CLASS="form_field_cell">
		<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
		<TR>
			<TD><b>File:</b></TD>
			<TD><INPUT TYPE="file" CLASS="input_text" SIZE="30" name="attachment_file" value="<?= $_REQUEST['attachment_file'] ?>"></TD>
		</TR>
		<TR>
			<TD><b>Description:</b></TD>
			<TD><INPUT TYPE="TEXT" CLASS="input_text" SIZE="50" name="attachment_description" value="<?= $_REQUEST['attachment_description'] ?>" maxlength="255"></TD>
		</TR>
		<TR>
			<TD COLSPAN="2"><INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Add Attachment"></TD>
		</TR>
		</TABLE>
	</TD>
</TR>
<?}?>
<?if($_REQUEST['mode'] == 'edit' && $project->hasRights(PROJECT_RIGHT_FULL)){?>
<TR>
	<TD CLASS="form_field_header_cell">Current User Access:</TD>
	<TD CLASS="form_field_cell">
<?  $project_rights = $project->getUserRights();
		for($i=0; $i<count($project_rights); $i++){
			$cur_user_ids[] = $project_rights[$i]['user_id'];?>
		<?= $project_rights[$i]['user_name'].'&nbsp;-&nbsp;'.$project_rights[$i]['level_name'] ?>&nbsp;&nbsp;
		<A HREF="<?= $_SERVER['PHP_SELF']."?id=".$project->id."&mode=delete_right&user_id=".$project_rights[$i]['user_id'] ?>">
		<IMG SRC="images/delete_small.gif" BORDER="0" WIDTH="13" HEIGHT="13" ALIGN="middle"/></A>&nbsp;<BR>
<?	}?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">New User Access:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="right_user_id" CLASS="input_text">
			<OPTION VALUE="0">Select User...</OPTION>
			<?= User::getSelectTags($_POST['right_user_id'], $cur_user_ids, FALSE) ?>
		</SELECT>&nbsp;&nbsp;
		<SELECT NAME="right_level" CLASS="input_text">
			<OPTION VALUE="0">Select Access Level...</OPTION>
<?		for($i=0; $i<count($project->right_level_names); $i++){?>
			<OPTION VALUE="<?= $i ?>"><?= $project->right_level_names[$i] ?></OPTION>
<?		}?>
		</SELECT>
		<INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Add User Access">
	</TD>
</TR>
<?}?>
<TR>
	<TD CLASS="form_field_header_cell">Current CC:</TD>
	<TD CLASS="form_field_cell">
<?  $ccs = $project->ccs;
		$cc_count = count($ccs);
		$cur_cc_ids = array();
		if($cc_count > 0){
			for($i=0; $i<$cc_count; $i++){
				$cur_cc_ids[] = $ccs[$i]->id;?>
			<?= $ccs[$i]->first_name.' '.$ccs[$i]->last_name ?>&nbsp;&nbsp;
		<A HREF="<?= $_SERVER['PHP_SELF']."?id=".$project->id."&mode=delete_cc&cc_id=".$ccs[$i]->id ?>">
		<IMG SRC="images/delete_small.gif" BORDER="0" WIDTH="13" HEIGHT="13" ALIGN="middle"/></A>&nbsp;<BR>
<?  	}
		}else{?>
		<b>No CCs Setup</b>
<?	} ?>
	</TD>
</TR>
<?if($_REQUEST['mode'] == 'edit' && $project->hasRights(PROJECT_RIGHT_EDIT)){?>
<TR>
	<TD CLASS="form_field_header_cell">Add CC:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="new_cc_id" CLASS="input_text">
			<OPTION VALUE="0">Select User...</OPTION>
			<?= User::getSelectTags($_POST['new_cc_id'], $cur_cc_ids, FALSE) ?>
		</SELECT>&nbsp;&nbsp;
		<INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Add CC">
	</TD>
</TR>
<?}?>
<TR>
	<TD CLASS="form_field_header_cell">Created On:</TD>
	<TD CLASS="form_field_cell"><?= $project->created_ts ? date("D M jS, Y \a\\t h:i:s A", $project->created_ts) : "" ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Last Updated:</TD>
	<TD CLASS="form_field_cell"><?= $project->updated_ts ? date("D M jS, Y \a\\t h:i:s A", $project->updated_ts) : "" ?></TD>
</TR>
<TR>
	<TD COLSPAN="2" CLASS="form_field_cell">
		<DIV ALIGN="right"><INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Save"></DIV>
	</TD>
</TR>
</TABLE>
</FORM>
<?
if($project->sales_com == 'Y')
	print('<SCRIPT>disableCom(false)</SCRIPT>');

require('footer.php'); ?>