<?
require_once('includes/common.php');
require_once('includes/Project.php');
require_once('includes/Task.php');
require_once('includes/PaymentSchedule.php');

checkLogin();

$project = new Project();
$tasks = array();

if(!empty($_REQUEST['id'])){
	$project->get($_REQUEST['id']);
	if(!$project->hasRights(PROJECT_RIGHT_VIEW)){
		fatal_error('Insufficent access rights for this project!');
	}

	$task = new Task();
	if($_REQUEST['filter'] == "all"){
		$tasks = $task->retrieveSet("t.project_id = ".$project->id);
	}else{
		$tasks = $task->retrieveSet("t.project_id = ".$project->id." AND s.completed = 'N'");
	}
	if($tasks === FALSE){
		$error_msg .= "Error retrieving tasks for project!\n";
		debug_message($task->getLastError());
	}
}else{
	fatal_error("Project ID must be supplied!\n");
}

// Get this projects payment schedule
$ps = new PaymentSchedule();
$items = $ps->getForProject($project->id);
if($items === FALSE){
	$error_msg .= "Error getting scheduled payments for project!\n";
	debug_message($ps->getLastError());
}

$title = "Tasks for ".$project->name;

require('header.php') ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell">Project Information</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Name:</TD>
	<TD CLASS="form_field_cell">
		<?= $project->name ?>&nbsp;&nbsp;
<?	if($project->hasRights(PROJECT_RIGHT_EDIT)){?>
		<a title="Edit Project" class="link1" href="project.php?mode=edit&id=<?= $project->id ?>">
		<img src="images/edit.gif" width="16" height="16" alt="edit" border="0" ALIGN="MIDDLE"  /></a>&nbsp;
<?	}?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Company:</TD>
	<TD CLASS="form_field_cell"><A title="Company Detail Center" HREF="company_detail.php?id=<?= $project->company_id ?>"><?= $project->company_name ?></A></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Spec Total:</TD>
	<TD CLASS="form_field_cell">$<?= number_format($project->getTotal(),2) ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Owner:</TD>
	<TD CLASS="form_field_cell"><A title="Resouce Detail Center" HREF="home_resource.php?id=<?= $project->owner_id ?>"><?= $project->owner_name ?></A></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Due Date:</TD>
	<TD CLASS="form_field_cell"><?= $project->due_ts>0 ? date("n/j/y", $project->due_ts) :  "None" ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Status:</TD>
	<TD CLASS="form_field_cell"><?= $project->status ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Priority:</TD>
	<TD CLASS="form_field_cell"><?= $project->priority ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Attachments:</TD>
	<TD CLASS="form_field_cell">
<?  $attachments = $project->attachments;
		$attachment_count = count($attachments);
		if($attachment_count > 0){
			for($i=0; $i<$attachment_count; $i++){ ?>
			<A title="View Attachment" HREF="attachment.php?id=<?= $attachments[$i]->id ?>"><?= $attachments[$i]->path ?></A>&nbsp;-&nbsp;<?= $attachments[$i]->description ?><BR>
<?  	}
		}else{?>
		<b>No Attachments</b>
<?	} ?>
	</TD>
</TR>
</TABLE><BR>

<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="6" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>
						Tasks&nbsp;
<?	if($project->hasRights(PROJECT_RIGHT_EDIT)){?>
						<A CLASS="link1" HREF="project_task.php?mode=add&project_id=<?= $project->id ?>">
						<img src="images/new.gif" width="16" height="16" title="New Task" border="0" /></A>
<?	}?>
					</TD>
					<TD ALIGN="right">
						Filter:&nbsp;
						<A CLASS="<?= $_REQUEST['filter'] == "all" ? "link3" : "link1" ?>" HREF="project_details.php?id=<?= $_REQUEST['id'] ?>&filter=all">All</A>&nbsp;|&nbsp;
						<A CLASS="<?= $_REQUEST['filter'] == "all" ? "link1" : "link3" ?>" HREF="project_details.php?id=<?= $_REQUEST['id'] ?>&filter=pending">Pending</A>
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">ID</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 1, 1, false)">Name</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 2, 1, false)">Status</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 3, 1, false)">Due Date</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 4, 1, false)">Priority</A></TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < count($tasks); $i++){ ?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $tasks[$i]->id ?></TD>
		<TD CLASS="dg_data_cell_1"><A title="Task Activities" HREF="task_activities.php?task_id=<?= $tasks[$i]->id ?>"><?= $tasks[$i]->name ?></A></TD>
		<TD CLASS="dg_data_cell_1"><?= $tasks[$i]->status ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $tasks[$i]->due_ts>0 ? date("n/j/y", $tasks[$i]->due_ts) :  "None" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $tasks[$i]->priority ?></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="task_activities.php?task_id=<?= $tasks[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/activity.gif" width="16" height="16" title="Task Activities" border="0" /></A>
<?	if($project->hasRights(PROJECT_RIGHT_EDIT)){?>
			&nbsp;|&nbsp;<A CLASS="link1" HREF="task_activity.php?mode=add&task_id=<?= $tasks[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/activity_add.gif" width="16" height="16" title="Add Activity" border="0" /></A>
			&nbsp;|&nbsp;<A CLASS="link1" HREF="project_task.php?mode=edit&id=<?= $tasks[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/edit.gif" width="16" height="16" title="Edit Task" border="0" /></A>
<?	}?>
<?	if($project->hasRights(PROJECT_RIGHT_FULL)){?>
			&nbsp;|&nbsp;<A CLASS="link1" HREF="project_task.php?mode=delete&id=<?= $tasks[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/delete.gif" width="16" height="16" title="Delete Task" border="0" /></A>&nbsp;
<?	}?>
		</TD>
	</TR>
<? }?>
</TBODY>
</TABLE>
<BR><BR>
<? if($project->billable == 'S' && $loggedin_user->hasRight('accounting')){	?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="6" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>
						Scheduled Payments&nbsp;
						<A CLASS="link1" HREF="payment_schedule.php?mode=add&project_id=<?= $project->id ?>">
						<img src="images/new.gif" width="16" height="16" title="New Scheduled Payment" border="0" /></A>
					</TD>
					<TD ALIGN="right">&nbsp;</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 0, 1, false)">ID</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 1, 2, false)">Due Date</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 2, 1, false)">Desc</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 3, 1, false)">Amount</A></TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId2">
<? for($i = 0; $i < count($items); $i++){ ?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $items[$i]->id ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $items[$i]->due_ts>0 ? date("n/j/y", $items[$i]->due_ts) :  "None" ?></TD>
		<TD CLASS="dg_data_cell_1"><A title="Edit Payment Schedule" HREF="payment_schedule.php?mode=edit&id=<?= $items[$i]->id ?>"><?= $items[$i]->description ?></A></TD>
		<TD CLASS="dg_data_cell_1">$<?= number_format($items[$i]->amount, 2) ?></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="payment_schedule.php?mode=edit&id=<?= $items[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/edit.gif" width="16" height="16" title="Edit Payment Schedule" border="0" /></A>
			&nbsp;|&nbsp;<A CLASS="link1" HREF="payment_schedule.php?mode=delete&id=<?= $items[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/delete.gif" width="16" height="16" title="Delete Payment Schedule" border="0" /></A>&nbsp;
		</TD>
	</TR>
<? }?>
</TBODY>
</TABLE>
<? } // if has accounting ?>
<? require('footer.php') ?>