<?
require_once('includes/common.php');
checkLogin();

require_once('includes/Project.php');
require_once('includes/Company.php');
require_once('includes/TaskActivity.php');
require_once('includes/Task.php');

$title = 'Reports';
$activity = new TaskActivity();

if(!isset($_REQUEST['billable'])){
	$_REQUEST['billable'] = 'N';
}

if($_REQUEST['save']){
	if(!$loggedin_user->hasRight('admin') && !$loggedin_user->isDeveloper()){
		$_REQUEST['billable'] = 'Y';
		$_REQUEST['company_id'] = $loggedin_user->company_id;
	}

	if(!$loggedin_user->hasRight('admin') && $loggedin_user->isDeveloper()){
		$_REQUEST['resource_id'] = $loggedin_user->id;
	}

	$_REQUEST['start_ts'] = getDateSelectorTS("start_ts");
	$_REQUEST['end_ts'] = getDateSelectorTS("end_ts");
	$activities = $activity->find($_REQUEST['start_ts'], $_REQUEST['end_ts']+86400, $_REQUEST['resource_id'], $_REQUEST['company_id'], $_REQUEST['billable']);
	if($activities === FALSE){
		$error_msg .= "Error getting report data!\n";
		debug_message($activity->getLastError());
	}
}

?>
<? require('header.php'); ?>
<FORM ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="GET">
<INPUT NAME="referrer" TYPE="hidden" VALUE="<?= $_REQUEST['referrer'] ?>">
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Company:</TD>
	<TD CLASS="form_field_cell">
<?	if($loggedin_user->hasRight('admin') || $loggedin_user->isDeveloper()){?>
		<SELECT NAME="company_id" CLASS="input_text">
			<OPTION VALUE="0">All</OPTION>
			<?= Company::getSelectTags($_REQUEST['company_id']) ?>
		</SELECT>
<?	}else{ ?>
		<INPUT NAME="company_id" TYPE="hidden" VALUE="<?= $loggedin_user->company_id ?>">
		<?= $loggedin_user->company ?>
<?	} ?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Resource:</TD>
	<TD CLASS="form_field_cell">
<?	if($loggedin_user->hasRight('admin') || !$loggedin_user->isDeveloper()){?>
		<SELECT NAME="resource_id" CLASS="input_text">
			<OPTION VALUE="0">All</OPTION>
			<?= User::getSelectTags($_REQUEST['resource_id']) ?>
		</SELECT>
<?	}else{ ?>
		<INPUT NAME="resource_id" TYPE="hidden" VALUE="<?= $loggedin_user->id ?>">
		<?= $loggedin_user->first_name.' '.$loggedin_user->last_name ?>
<?	} ?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Start:</TD>
	<TD CLASS="form_field_cell"><?= getDateSelector($_REQUEST['start_ts'], "start_ts") ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">End:</TD>
	<TD CLASS="form_field_cell"><?= getDateSelector($_REQUEST['end_ts'], "end_ts") ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Billable Only?</TD>
	<TD CLASS="form_field_cell">
<?	if($loggedin_user->hasRight('admin') || $loggedin_user->isDeveloper()){?>
		<INPUT NAME="billable" TYPE="radio" VALUE="Y" <?= checked($_REQUEST['billable'], "Y") ?>>Yes&nbsp;
		<INPUT NAME="billable" TYPE="radio" VALUE="N" <?= checked($_REQUEST['billable'], "N") ?>>No&nbsp;
<?	}else{ ?>
		<INPUT NAME="billable" TYPE="hidden" VALUE="Y">
		Yes
<?	} ?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Show Graphs?</TD>
	<TD CLASS="form_field_cell">
<?	if($loggedin_user->isDeveloper()){?>
		<INPUT NAME="graph_company" TYPE="checkbox" VALUE="Y" <?= checked($_REQUEST['graph_company'], "Y") ?>>Time By Company<BR>
<?	} ?>
		<INPUT NAME="graph_project" TYPE="checkbox" VALUE="Y" <?= checked($_REQUEST['graph_project'], "Y") ?>>Time By Project<BR>
	</TD>
</TR>
<TR>
	<TD COLSPAN="2" CLASS="form_field_cell">
		<DIV ALIGN="right"><INPUT TYPE="submit" NAME="save" CLASS="button" VALUE="Report"></DIV>
	</TD>
</TR>
</TABLE>
</FORM>
<?
if(count($activities) > 0){
	$company_totals = array();
?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="6" CLASS="form_header_cell">
			Task Activities&nbsp;
			<A CLASS="link1" HREF="report_export.php?<?= $_SERVER['QUERY_STRING'] ?>">
			<img src="images/export.png" width="16" height="16" title="Export Report" border="0" /></A>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 0, 0, false)">Company</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 1, 1, false)">Project</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 2, 0, false)">Task</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 4, 0, false)">Started</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 5, 0, false)">Completed</A></TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId1">
<?	$total_time = 0;
	foreach($activities as $act){
		$total_time += ($act->end_ts - $act->start_ts);
		$company_totals[$act->company] += ($act->end_ts - $act->start_ts);
		$project_totals[$act->project] += ($act->end_ts - $act->start_ts);
	?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $act->company_name ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $act->project_name ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $act->task_name ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $act->start_ts>0 ? date("n/j/y H:i", $act->start_ts) : "None" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $act->end_ts>0 ? date("n/j/y H:i", $act->end_ts) : "None" ?></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="task_activities.php?task_id=<?= $act->task_id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/activity.gif" width="16" height="16" alt="Activities" border="0" /></A>&nbsp;|&nbsp;
			<A CLASS="link1" HREF="task_activity.php?mode=edit&id=<?= $act->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/edit.gif" width="16" height="16" alt="Edit" border="0" /></A>&nbsp;
		</TD>
	</TR>
<?
	}?>
	</TBODY>
	<TR>
		<TD COLSPAN="4" CLASS="form_header_cell" ALIGN="right">Total Time Spent:</TD>
		<TD CLASS="form_field_cell"><?= formatLengthOfTime($total_time) ?></TD>
		<TD CLASS="form_header_cell" ALIGN="right">&nbsp;</TD>
	</TR>
</TABLE>
<BR>
<? if($_REQUEST['graph_company'] == 'Y'){ ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="100%">
<TR>
	<TD WIDTH="40%">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
			<TR>
				<TD COLSPAN="2" CLASS="form_header_cell">Company Totals</TD>
			</TR>
			<TR>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 0, 1, false)">Name</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 1, 0, false)">Hours</A></TD>
			</TR>
			<TBODY ID="bodyId2">
		<?$total_company_time = 0;
			foreach($company_totals as $name => $total){
					$total_company_time += $total;
		?>
			<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
				<TD CLASS="dg_data_cell_1"><?= $name ?></TD>
				<TD CLASS="dg_data_cell_1"><?= formatLengthOfTime($total) ?></TD>
			</TR>
		<? }?>
			</TBODY>
			<TR>
				<TD CLASS="form_header_cell" ALIGN="right">Total Time Spent:</TD>
				<TD CLASS="form_field_cell" COLSPAN="2"><?= formatLengthOfTime($total_company_time) ?></TD>
			</TR>
		</TABLE>
	</TD>
	<TD>
	<IMG SRC="<?= "graph.php?type=company&start_ts=".$_REQUEST['start_ts']."&end_ts=".$_REQUEST['end_ts']."&resource_id=".$_REQUEST['resource_id']."&company_id=".$_REQUEST['company_id']."&unbilled=".$_REQUEST['unbilled'] ?>" BORDER="0"></TD>
</TR>
</TABLE>
<? }  //if graph_company 
?>
<? if($_REQUEST['graph_project'] == 'Y'){?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="100%">
<TR>
	<TD WIDTH="40%">
		<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
			<TR>
				<TD COLSPAN="2" CLASS="form_header_cell">Project Totals</TD>
			</TR>
			<TR>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 0, 1, false)">Name</A></TD>
				<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 1, 0, false)">Hours</A></TD>
			</TR>
			<TBODY ID="bodyId2">
		<?$total_project_time = 0;
			foreach($project_totals as $name => $total){
					$total_project_time += $total;
		?>
			<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
				<TD CLASS="dg_data_cell_1"><?= $name ?></TD>
				<TD CLASS="dg_data_cell_1"><?= formatLengthOfTime($total) ?></TD>
			</TR>
		<? }?>
			</TBODY>
			<TR>
				<TD CLASS="form_header_cell" ALIGN="right">Total Time Spent:</TD>
				<TD CLASS="form_field_cell" COLSPAN="2"><?= formatLengthOfTime($total_project_time) ?></TD>
			</TR>
		</TABLE>
	</TD>
	<TD>
	<IMG SRC="<?= "graph.php?type=project&start_ts=".$_REQUEST['start_ts']."&end_ts=".$_REQUEST['end_ts']."&resource_id=".$_REQUEST['resource_id']."&company_id=".$_REQUEST['company_id']."&unbilled=".$_REQUEST['unbilled'] ?>" BORDER="0">
	</TD>
</TR>
</TABLE>
<? }
}
?>
<? require('footer.php'); ?>
