<?
require_once('includes/common.php');
require_once('includes/Project.php');
require_once('includes/Task.php');
require_once('includes/TaskActivity.php');
require_once('includes/PaymentSchedule.php');

checkLogin();

$project = new Project();
$task = new Task();
$ta = new TaskActivity();
$activities = array();

if(!empty($_REQUEST['task_id'])){
	$task->get($_REQUEST['task_id']);
	$project->get($task->project_id);
	if(!$project->hasRights(PROJECT_RIGHT_VIEW)){
		fatal_error('Insufficent access rights for this project!');
	}
	$activities = $ta->retrieveSet("task_id = ".$task->id);
	if($activities === FALSE){
		$error_mgs += "Error getting list of task activities!\n";
		debug_message($ta->getLastError());
	}
}else{
	fatal_error("Task ID must be supplied!\n");
}

$my_url = $_SERVER['PHP_SELF']."?task_id=".$task->id."&";

$_REQUEST['detail'] = strtolower(substr($_REQUEST['detail'],0,1)) == "y" ? TRUE : FALSE;

$title = "Activities for ".$task->name;

$total_time = 0;

// Get this tasks payment schedule
$ps = new PaymentSchedule();
$items = $ps->getForTask($task->id);
if($items === FALSE){
	$error_msg .= "Error getting scheduled payments for project!\n";
	debug_message($ps->getLastError());
}


require('header.php') ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell">Task Information</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Project Name:</TD>
	<TD CLASS="form_field_cell">
		<?= $project->name ?>&nbsp;&nbsp;
		<A CLASS="link1" HREF="project_details.php?id=<?= $project->id ?>">
		<img src="images/properties.gif" width="16" height="16" title="Project Details" border="0" ALIGN="MIDDLE" /></A>&nbsp;&nbsp;
<?	if($project->hasRights(PROJECT_RIGHT_EDIT)){?>
		<A CLASS="link1" HREF="project.php?mode=edit&id=<?= $project->id ?>">
		<img src="images/edit.gif" width="16" height="16" title="Edit Project" border="0" ALIGN="MIDDLE"  /></A>&nbsp;
<?	}?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Company:</TD>
	<TD CLASS="form_field_cell"><A title="Company Detail Center" HREF="company_detail.php?id=<?= $project->company_id ?>"><?= $project->company_name ?></A></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Project Due Date:</TD>
	<TD CLASS="form_field_cell"><?= $project->due_ts>0 ? date("n/j/y", $project->due_ts) :  "None" ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Status:</TD>
	<TD CLASS="form_field_cell"><?= $project->status ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Priority:</TD>
	<TD CLASS="form_field_cell"><?= $project->priority ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Project Attachments:</TD>
	<TD CLASS="form_field_cell">
<?  $attachments = $project->attachments;
		$attachment_count = count($attachments);
		if($attachment_count > 0){
			for($i=0; $i<$attachment_count; $i++){ ?>
			<A title="View Attachment" HREF="attachment.php?id=<?= $attachments[$i]->id ?>"><?= $attachments[$i]->path ?></A>&nbsp;-&nbsp;<?= $attachments[$i]->description ?><BR>
<?  	}
		}else{?>
		<b>No Attachments</b>
<?	} ?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Expenses:</TD>
	<TD CLASS="form_field_cell">
<?  $expenses = $project->getExpenses();
		$expense_count = count($expenses);
		if($expense_count > 0){
			for($i=0; $i<$expense_count; $i++){ ?>
			<?= $expenses[$i]->description . " - " . $expenses[$i]->price ?><BR>
<?  	}
		}else{?>
		<b>No Expenses</b>
<?	} ?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Task Name:</TD>
	<TD CLASS="form_field_cell">
		<?= $task->name ?>&nbsp;
<?	if($project->hasRights(PROJECT_RIGHT_EDIT)){?>
		<A CLASS="link1" HREF="project_task.php?mode=edit&id=<?= $task->id ?>">
		<img src="images/edit.gif" width="16" height="16" title="Edit Task" border="0" ALIGN="middle"  /></A>
<?	}?>
		</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Task Due Date:</TD>
	<TD CLASS="form_field_cell"><?= $task->due_ts>0 ? date("n/j/y", $task->due_ts) :  "None" ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Task Type:</TD>
	<TD CLASS="form_field_cell"><?= $task->type ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell" NOWRAP>Task Description:</TD>
	<TD CLASS="form_field_cell">
<? if($task->type == 'FREEFORM'){ ?>
		<?= nl2br($task->description) ?>
<? }else{ ?>
			<?= $task->getTaskItemsHTML(0, 'VIEW') ?>
<? } //end if task type ?>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Task Attachments:</TD>
	<TD CLASS="form_field_cell">
<?  $attachments = $task->attachments;
		$attachment_count = count($attachments);
		if($attachment_count > 0){
			for($i=0; $i<$attachment_count; $i++){ ?>
			<A title="View Attachment" HREF="attachment.php?id=<?= $attachments[$i]->id ?>"><?= $attachments[$i]->path ?></A>&nbsp;-&nbsp;<?= $attachments[$i]->description ?><BR>
<?  	}
		}else{?>
		<b>No Attachments</b>
<?	} ?>
	</TD>
</TR>
</TABLE><BR>

<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="6" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>Activities&nbsp;
<?	if($project->hasRights(PROJECT_RIGHT_EDIT)){?>
						<A CLASS="link1" HREF="task_activity.php?mode=add&task_id=<?= $task->id ?>"><img src="images/activity_add.gif" width="16" height="16" title="New Activity" border="0" /></A>
<?	}?>
					</TD>
					<TD ALIGN="right">
						Detail:&nbsp;
						<A CLASS="<?= $_REQUEST['detail'] == TRUE ? "link3" : "link1" ?>" HREF="<?= $my_url."detail=y" ?>">Yes</A>&nbsp;|&nbsp;
						<A CLASS="<?= $_REQUEST['detail'] == TRUE ? "link1" : "link3" ?>" HREF="<?= $my_url."detail=n" ?>">No</A>
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">ID</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 2, 0, false)">Start</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 3, 0, false)">End</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 4, 0, false)">Time Spent</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 5, 0, false)">Billed</A></TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < count($activities); $i++){
		$act_time = ($activities[$i]->end_ts>0 &&  $activities[$i]->start_ts>0 ? $activities[$i]->end_ts - $activities[$i]->start_ts : 0);
		$total_time += $act_time;
?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->id ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->start_ts>0 ? date("n/j/y H:i", $activities[$i]->start_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->end_ts>0 ? date("n/j/y H:i", $activities[$i]->end_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $act_time>0 ? formatLengthOfTime($act_time) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->invoice>0 ? $activities[$i]->invoice :  "No" ?></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
<?	if($project->hasRights(PROJECT_RIGHT_EDIT)){?>
			<A CLASS="link1" HREF="task_activity.php?mode=edit&id=<?= $activities[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/edit.gif" width="16" height="16" title="Edit Activity" border="0" /></A>&nbsp;|&nbsp;
<?	}?>
<?	if($project->hasRights(PROJECT_RIGHT_FULL)){?>
			<A CLASS="link1" HREF="task_activity.php?mode=delete&id=<?= $activities[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/delete.gif" width="16" height="16" title="Delete Activity" border="0" /></A>&nbsp;
<?	}?>
		</TD>
	</TR>
<? if($_REQUEST['detail']){?>
	<TR>
		<TD COLSPAN="7" CLASS="dg_data_cell_1">
		<?= nl2br(stripslashes($activities[$i]->text)) ?>
<?	if($task->type == 'ITEMIZED'){?>
		<?= "<BR>".$activities[$i]->getCompletedItemsHTML() ?>
<?	} //end if itemized ?>
		</TD>
	</TR>
<? 	if($i != count($activities)-1){?>
	<TR>
		<TD COLSPAN="7" CLASS="dg_header_cell">&nbsp;</TD>
	</TR>
<? 	} //If not last ?>
<? } //If detail ?>
<? }?>
</TBODY>
	<TR>
		<TD COLSPAN="3" CLASS="form_header_cell" ALIGN="right">Time Spent:</TD>
		<TD CLASS="form_field_cell"><?= formatLengthOfTime($total_time) ?></TD>
		<TD COLSPAN="2" CLASS="form_header_cell" ALIGN="right"></TD>
	</TR>
</TABLE>
<BR><BR>
<? if($task->billable == 'S' && $loggedin_user->hasRight('accounting')){	?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="6" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>
						Scheduled Payments&nbsp;
						<A CLASS="link1" HREF="payment_schedule.php?mode=add&task_id=<?= $task->id ?>">
						<img src="images/new.gif" width="16" height="16" title="New Scheduled Payment" border="0" /></A>
					</TD>
					<TD ALIGN="right">&nbsp;</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 0, 1, false)">ID</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 1, 2, false)">Due Date</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 2, 1, false)">Desc</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId2', 3, 1, false)">Amount</A></TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId2">
<? for($i = 0; $i < count($items); $i++){ ?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $items[$i]->id ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $items[$i]->due_ts>0 ? date("n/j/y", $items[$i]->due_ts) :  "None" ?></TD>
		<TD CLASS="dg_data_cell_1"><A title="Edit Payment Schedule" HREF="payment_schedule.php?mode=edit&id=<?= $items[$i]->id ?>"><?= $items[$i]->description ?></A></TD>
		<TD CLASS="dg_data_cell_1">$<?= number_format($items[$i]->amount, 2) ?></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="payment_schedule.php?mode=edit&id=<?= $items[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/edit.gif" width="16" height="16" title="Edit Payment Schedule" border="0" /></A>
			&nbsp;|&nbsp;<A CLASS="link1" HREF="payment_schedule.php?mode=delete&id=<?= $items[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/delete.gif" width="16" height="16" title="Delete Payment Schedule" border="0" /></A>&nbsp;
		</TD>
	</TR>
<? }?>
</TBODY>
</TABLE>
<? } // if has accounting ?>

<? require('footer.php') ?>