<?
require_once('includes/common.php');
checkLogin();

require_once('includes/Project.php');
require_once('includes/Task.php');
require_once('includes/TaskActivity.php');
require_once('includes/Expense.php');

$title = '';
$task_activity = new TaskActivity();
$task = new Task();
$project = new Project();
$user = new User();
$disabled = false;

if($_REQUEST['mode'] == 'add'){
	$title = "Add Task Activity";
	if(empty($_REQUEST['task_id'])){
		fatal_error("No Task ID specified!\n");
	}else{
		$task_activity->task_id = $_REQUEST['task_id'];
		$task_activity->completed_ts = time();
		$task_activity->user_id = $loggedin_user->id;
		if($task->get($task_activity->task_id) === FALSE){
			fatal_error("Could not retreive task!");
			debug_message($task->getLastError());
		}
		if($project->get($task->project_id) === FALSE){
			fatal_error("Could not retreive project!");
			debug_message($project->getLastError());
		}
		if(!$project->hasRights(PROJECT_RIGHT_EDIT)){
			fatal_error('Insufficent access rights for this project!');
		}
		$task_activity->hourly_cost = $loggedin_user->hourly_rate;
		$company = $project->getCompany();
		if($company === FALSE){
			fatal_error("Could not get company information!\n");
			debug_message($project->getLastError());			
		}
		$task_activity->hourly_rate = $company->hourly_rate;
		$sct = $task->getSalesCommissionType();
		$task_activity->sales_com_type_id = $sct->id;
	}

	if($_POST['save']){
		if(!isset($_POST['user_id'])) $_POST['user_id'] = $loggedin_user->id;
		$_POST['start_ts'] = getDateSelectorTS("start_ts");
		$_POST['end_ts'] = getDateSelectorTS("end_ts");
		if($user->get($_POST['user_id']) === FALSE){
			fatal_error("Could not get user information!\n");
			debug_message($user->getLastError());
		}
		$task_activity->updateFromAssocArray($_POST);
		if($task_activity->add()){
			if(is_array($_POST['item_ids'])){
				if($task_activity->setItems($_POST['item_ids']) === FALSE){
					$error_msg .= "Error adding completed items to activity!\n";
					debug_message($task_activity->getLastError());
				}
			}
			if(is_array($_POST['expense'])){
				if(!empty($_POST['expense']['description']) && 
				   !empty($_POST['expense']['cost']) && 
				   !empty($_POST['expense']['price'])){
					$exp = new Expense();
					$exp->task_id = $task_activity->task_id;
					$exp->description = $_POST['expense']['description'];
					$exp->cost = floatval($_POST['expense']['cost']);
					$exp->price = floatval($_POST['expense']['price']);
					$exp->created_ts = time();
					if($exp->add() === FALSE){
						$error_msg .= "Error adding new expense!\n";
						debug_message($exp->getLastError());	
					}
				}
			}
			if($project->sendUpdateNotification(array("Added new task activity ".$GLOBALS['CONFIG']['url'].'/task_activity.php?mode=edit&id='.$task_activity->id)) === FALSE){
				$error_msg .= "Error sending update notification!\n";
				debug_message($project->getLastError());
			}

			if(empty($error_msg)){
				goBack();
			}
		}else{
			$error_msg .= "Error adding Task Activity!\n";
			debug_message($task_activity->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'edit'){
	$title = "Edit Task Activity";
	if(empty($_REQUEST['id'])){
		$error_msg .= "Error: No ID specified!\n";
	}else{
		if(!$task_activity->get($_REQUEST['id'])){
			fatal_error("Could not retreive task activity!");
			debug_message($task_activity->getLastError());
		}
		if($task->get($task_activity->task_id) === FALSE){
			fatal_error("Could not retreive task!");
			debug_message($task->getLastError());
		}
		if($project->get($task->project_id) === FALSE){
			fatal_error("Could not retreive project!");
			debug_message($project->getLastError());
		}
		if(!$project->hasRights(PROJECT_RIGHT_EDIT)){
			fatal_error('Insufficent access rights for this project!');
		}
		if($task_activity->isBilled() || $task_activity->isPaid()){
			$disabled = true;	
		}
	}

	if($_POST['save']){
		$_POST['start_ts'] = getDateSelectorTS("start_ts");
		$_POST['end_ts'] = getDateSelectorTS("end_ts");
		$task_activity->updateFromAssocArray($_POST);
		if($task_activity->update()){
			if(is_array($_POST['item_ids'])){
				if($task_activity->setItems($_POST['item_ids']) === FALSE){
					$error_msg .= "Error adding completed items to activity!\n";
					debug_message($task_activity->getLastError());
				}
			}
			if(is_array($_POST['expense'])){
				if(!empty($_POST['expense']['description']) && 
				   !empty($_POST['expense']['cost']) && 
				   !empty($_POST['expense']['price'])){
					$exp = new Expense();
					$exp->task_id = $task_activity->task_id;
					$exp->description = $_POST['expense']['description'];
					$exp->cost = floatval($_POST['expense']['cost']);
					$exp->price = floatval($_POST['expense']['price']);
					$exp->created_ts = time();
					if($exp->add() === FALSE){
						$error_msg .= "Error adding new expense!\n";
						debug_message($exp->getLastError());	
					}
				}
			}
			if($project->sendUpdateNotification(array("Updated task activity ".$GLOBALS['CONFIG']['url'].'/task_activity.php?mode=edit&id='.$task_activity->id)) === FALSE){
				$error_msg .= "Error sending update notification!\n";
				debug_message($project->getLastError());
			}

			if(empty($error_msg)){
				goBack();
			}
		}else{
			$error_msg .= "Error updating Task Activity!\n";
			debug_message($task_activity->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'delete'){
	$title = "Delete Task";
	if(!isset($_REQUEST['id'])){
		fatal_error("Task activity id must be supplied!");
	}
	if(!$task_activity->get($_REQUEST['id'])){
		fatal_error("Could not retreive task activity!");
		debug_message($task_activity->getLastError());
	}
	if($task_activity->isBilled() || $task_activity->isPaid()){
		fatal_error("Can not delete a task that is attached to an invoice or a check!");	
	}
	if($task->get($task_activity->task_id) === FALSE){
		fatal_error("Could not retreive task!");
		debug_message($task->getLastError());
	}
	if($project->get($task->project_id) === FALSE){
		fatal_error("Could not retreive project!");
		debug_message($project->getLastError());
	}
	if(!$project->hasRights(PROJECT_RIGHT_FULL)){
		fatal_error('Insufficent access rights for this project!');
	}else{
		if($task_activity->delete($_REQUEST['id'])){
			if($project->sendUpdateNotification(array("Deleted task activity ID ".$_REQUEST['id'])) === FALSE){
				$error_msg .= "Error sending update notification!\n";
				debug_message($project->getLastError());
			}else{
				goBack();
			}
		}else{
			fatal_error("Error deleting Task Activity!\n");
			debug_message($task_activity->getLastError());
		}
	}
}else{
	fatal_error("Error Invalid mode!\n");
}

$hourly_rates = $user->getHourlyRates();
if($hourly_rates === FALSE){
	$error_msg .= "Could not get hourly rates for all users!";
	debug_message($user->getLastError());	
}
?>
<? require('header.php'); ?>
<SCRIPT>
	var rates = new Array();
<?	foreach($hourly_rates as $id => $rate){?>
		<?= "rates[".$id."] = \"".$rate."\";" ?> 
<?	} ?>
	function updateHourlyCost(){
		var oHourlyCost = document.getElementById('hourly_cost');
		var oResource = document.getElementById('user_id');
		oHourlyCost.value = rates[oResource.options[oResource.selectedIndex].value];	
	}
</SCRIPT>
<FORM ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="POST">
<INPUT NAME="id" TYPE="hidden" VALUE="<?= $_REQUEST['id'] ?>">
<INPUT NAME="task_id" TYPE="hidden" VALUE="<?= $task_activity->task_id ?>">
<INPUT NAME="mode" TYPE="hidden" VALUE="<?= $_REQUEST['mode'] ?>">
<INPUT NAME="referrer" TYPE="hidden" VALUE="<?= $_REQUEST['referrer'] ?>">
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell">Task Information</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Project Name:</TD>
	<TD CLASS="form_field_cell">
		<?= $project->name ?>&nbsp;&nbsp;
		<A CLASS="link1" HREF="project_details.php?id=<?= $project->id ?>">
		<img src="images/properties.gif" width="16" height="16" title="Project Detail" border="0" ALIGN="MIDDLE" /></A>&nbsp;&nbsp;
		<A CLASS="link1" HREF="project.php?mode=edit&id=<?= $project->id ?>">
		<img src="images/edit.gif" width="16" height="16" title="Edit Project" border="0" ALIGN="MIDDLE"  /></A>&nbsp;
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Company:</TD>
	<TD CLASS="form_field_cell"><A title="Company Detail Center" HREF="company_detail.php?id=<?= $project->company_id ?>"><?= $project->company_name ?></A></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Project Due Date:</TD>
	<TD CLASS="form_field_cell"><?= $project->due_ts>0 ? date("n/j/y", $project->due_ts) :  "None" ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Status:</TD>
	<TD CLASS="form_field_cell"><?= $project->status ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Priority:</TD>
	<TD CLASS="form_field_cell"><?= $project->priority ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Task Name:</TD>
	<TD CLASS="form_field_cell">
		<?= $task->name ?>&nbsp;
		<A CLASS="link1" HREF="project_task.php?mode=edit&id=<?= $task->id ?>">
		<img src="images/edit.gif" width="16" height="16" title="Edit Task" border="0" ALIGN="middle"  /></A>
		</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Task Due Date:</TD>
	<TD CLASS="form_field_cell"><?= $task->due_ts>0 ? date("n/j/y", $task->due_ts) :  "None" ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell" NOWRAP>Task Description:</TD>
	<TD CLASS="form_field_cell"><?= nl2br($task->description) ?></TD>
</TR>
</TABLE><BR>

<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<? if($loggedin_user->hasRight('accounting')){ ?>
<TR>
	<TD CLASS="form_field_header_cell">Hourly Rate:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="hourly_rate" ID="hourly_rate" CLASS="input_text" SIZE="7" TYPE="text" <?= $disabled ? 'DISABLED' : ''?> VALUE="<?= $task_activity->hourly_rate ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Hourly Cost:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="hourly_cost" ID="hourly_cost" CLASS="input_text" SIZE="7" TYPE="text" <?= $disabled ? 'DISABLED' : ''?> VALUE="<?= $task_activity->hourly_cost ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Cost Transaction ID:</TD>
	<TD CLASS="form_field_cell"><?= $task_activity->cost_trans_id ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Sales Commission Type:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="sales_com_type_id" CLASS="input_text" <?= $disabled ? 'DISABLED' : ''?>>
			<OPTION VALUE="0">None</OPTION>
			<?= SalesCommissionType::getSelectTags($task_activity->sales_com_type_id) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Commission Transaction ID:</TD>
	<TD CLASS="form_field_cell"><?= $task_activity->com_trans_id ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Resource:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="user_id" ID="user_id" CLASS="input_text" onchange="updateHourlyCost()" <?= $disabled ? 'DISABLED' : ''?>>
			<?= User::getSelectTags($task_activity->user_id) ?>
		</SELECT>
	</TD>
</TR>
<? } //if accounting 
?>
<? if(!$disabled){ ?>
<TR>
	<TD CLASS="form_field_header_cell">Start:</TD>
	<TD CLASS="form_field_cell"><?= getDateSelector($task_activity->start_ts, "start_ts", TRUE, 'start_ts_1', 5, "mirrorDate(1);") ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">End:</TD>
	<TD CLASS="form_field_cell"><?= getDateSelector($task_activity->end_ts, "end_ts", TRUE, 'end_ts_1') ?></TD>
</TR>
<? }else{ ?>
<TR>
	<TD CLASS="form_field_header_cell">Start:</TD>
	<TD CLASS="form_field_cell"><?= date("n/j/y H:i", $task_activity->start_ts) ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">End:</TD>
	<TD CLASS="form_field_cell"><?= date("n/j/y H:i", $task_activity->end_ts) ?></TD>
</TR>	
<? } ?>
<? if($task->type == 'FREEFORM'){ ?>
<TR>
	<TD CLASS="form_field_header_cell">Activity Details:</TD>
	<TD CLASS="form_field_cell"><TEXTAREA NAME="text" CLASS="input_text" COLS="70" ROWS="15"><?= $task_activity->text ?></TEXTAREA></TD>
</TR>
<? }else{?>
<TR>
	<TD CLASS="form_field_header_cell">Activity Notes:</TD>
	<TD CLASS="form_field_cell"><TEXTAREA NAME="text" CLASS="input_text" COLS="70" ROWS="3"><?= $task_activity->text ?></TEXTAREA></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Items:</TD>
	<TD CLASS="form_field_cell"><?= $task->getTaskItemsHTML($task_activity->id) ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">New Task:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="new_item_parent" CLASS="input_text">
			<OPTION VALUE="0">No Parent</OPTION>
			<?= TaskItem::getParentSelectTags($task->id) ?>
		</SELECT>
		<INPUT NAME="new_item" CLASS="input_text" SIZE="70" TYPE="text">
	</TD>
</TR>
<? } //if type 
?>
<TR>
	<TD CLASS="form_field_header_cell">Add Expense:</TD>
	<TD CLASS="form_field_cell">
		<input type="text" name="expense[description]" value="" size="40" maxlength="40"/>
  		<b>Cost:</b><input type="text" name="expense[cost]" value="" size="8" maxlength="10"/>
  		<b>Price:</b><input type="text" name="expense[price]" value="" size="8" maxlength="10"/>
	</TD>
</TR>
<TR>
	<TD COLSPAN="2" CLASS="form_field_cell">
		<DIV ALIGN="right"><INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Save"></DIV>
	</TD>
</TR>
</TABLE>
</FORM>
<? require('footer.php'); ?>